#!/usr/bin/perl -w

# If memory is of any use this code converts a bitmap file to an ascii
# representation useful for debugging the bitmap code in THINC.
# (i.e. something like 10010111000)
#
# Released to the public domain. You may use this
# code any way you wish, private, educational, or commercial.  It's free.

use strict;

my ($in, $header, $bits);

$in = shift or die "bitmap file?";

open(IN, $in) or die "couldn't open $in: $!";

read (IN, $header, 20) or die "couldn't read header: $!";

my ($w, $h, $fg, $bg, $sz) = unpack('NNNNN', $header);

print ("$w, $h, $fg, $bg, $sz\n");

read(IN, $bits, $sz) or die "couldn't read data: $!\n";
close(IN);

my ($bitsz, $curr, $val);

$bitsz = $sz*8;
$curr = 0;

#my $str = '';

while($bitsz) {
	$val = vec ($bits, $curr, 1);
	$bitsz--;
	$curr++;

	print ("$val");
	if($curr % $w == 0) {
		print("\n");
	}
#	$str .= $val;
#	if($curr % 8 == 0) {
#		$str = reverse($str);
#		print ("$str");
#		$str = '';
#	}	
#	if($curr % $w == 0) {
#		$str = reverse($str);
#		print ("$str\n");
#		$str = '';
#	}
}
printf("\n");
