/*
 * header for thinc's resize library
 *
 * Authors: 
 * Ricardo A. Baratto - Network Computing Lab - Columbia University
 */

/* set tabstop 8 */

#include "thincCommon.h"

int thinc_resize8(char *in, char *out, unsigned int inw, 
        unsigned int inh, unsigned int outw, unsigned outh, 
        unsigned int instride, unsigned int outstride);
int thinc_resize16(char *in, char *out, unsigned int inw, 
        unsigned int inh, unsigned int outw, unsigned outh, 
        unsigned int instride, unsigned int outstride);
int thinc_resize32(char *in, char *out, unsigned int inw, 
        unsigned int inh, unsigned int outw, unsigned outh, 
        unsigned int instride, unsigned int outstride);
int thinc_resize_yv12(
	char *iny, char *inu, char *inv,
	char *outy, char *outu,  char *outv,
	unsigned int inw, unsigned int inh, unsigned int outw, unsigned outh,
	unsigned int yipitch, unsigned int uvipitch,
	unsigned int yopitch, unsigned int uvopitch);

int thinc_resize_yuy2(
	char *in, char *out,
	unsigned int inw, unsigned int inh,
	unsigned int outw, unsigned int outh,
	unsigned int instride, unsigned int outstride);

int thinc_resize_uyvy(
	char *in, char *out,
	unsigned int inw, unsigned int inh,
	unsigned int outw, unsigned int outh,
	unsigned int instride, unsigned int outstride);
